/*
 * PHP Reformatter - A tool to make dirty PHP code readable.
 * Copyright (C) 2007 Joris van Rooij <jorrizza@jrrzz.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#ifndef PREPROCESSOR_H
#define PREPROCESSOR_H

#include "codeblock.h"
#include "bool.h"

#define PREPROC_BUFSIZE 256
#define GLOBAL_BUFSIZE 1048576
#define PREPROC_MAXDEPTH 256
#define VALID_VARIABLE(c) ((c >= 0x30 && c <= 0x39) || (c >= 0x41 && c <= 0x5A) || (c >= 0x61 && c <= 0x7A) || c == 0x5F)
#define VALID_FUNCTION(c) VALID_VARIABLE(c)
#define VALID_UNDEF(c) VALID_VARIABLE(c)
#define VALID_NUMBER(c) (c >= 0x30 && c <= 0x39)
#define VALID_DEFINE(c) ((c >= 0x30 && c <= 0x39) || (c >= 0x41 && c <= 0x5A) || c == 0x5F)

int preprocess (char *code, size_t len, struct codeblock_s *codeblock, char *filename, bool loose);

#endif
